package com.hfkj.entity;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class BsOrderRefundExample {
    protected String orderByClause;

    protected boolean distinct;

    protected List<Criteria> oredCriteria;

    private Integer limit;

    private Long offset;

    public BsOrderRefundExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    public void setLimit(Integer limit) {
        this.limit = limit;
    }

    public Integer getLimit() {
        return limit;
    }

    public void setOffset(Long offset) {
        this.offset = offset;
    }

    public Long getOffset() {
        return offset;
    }

    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(Long value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(Long value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(Long value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(Long value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(Long value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(Long value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<Long> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<Long> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(Long value1, Long value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(Long value1, Long value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andMerIdIsNull() {
            addCriterion("mer_id is null");
            return (Criteria) this;
        }

        public Criteria andMerIdIsNotNull() {
            addCriterion("mer_id is not null");
            return (Criteria) this;
        }

        public Criteria andMerIdEqualTo(Long value) {
            addCriterion("mer_id =", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdNotEqualTo(Long value) {
            addCriterion("mer_id <>", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdGreaterThan(Long value) {
            addCriterion("mer_id >", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdGreaterThanOrEqualTo(Long value) {
            addCriterion("mer_id >=", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdLessThan(Long value) {
            addCriterion("mer_id <", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdLessThanOrEqualTo(Long value) {
            addCriterion("mer_id <=", value, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdIn(List<Long> values) {
            addCriterion("mer_id in", values, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdNotIn(List<Long> values) {
            addCriterion("mer_id not in", values, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdBetween(Long value1, Long value2) {
            addCriterion("mer_id between", value1, value2, "merId");
            return (Criteria) this;
        }

        public Criteria andMerIdNotBetween(Long value1, Long value2) {
            addCriterion("mer_id not between", value1, value2, "merId");
            return (Criteria) this;
        }

        public Criteria andOrderNoIsNull() {
            addCriterion("order_no is null");
            return (Criteria) this;
        }

        public Criteria andOrderNoIsNotNull() {
            addCriterion("order_no is not null");
            return (Criteria) this;
        }

        public Criteria andOrderNoEqualTo(String value) {
            addCriterion("order_no =", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotEqualTo(String value) {
            addCriterion("order_no <>", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoGreaterThan(String value) {
            addCriterion("order_no >", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoGreaterThanOrEqualTo(String value) {
            addCriterion("order_no >=", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLessThan(String value) {
            addCriterion("order_no <", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLessThanOrEqualTo(String value) {
            addCriterion("order_no <=", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoLike(String value) {
            addCriterion("order_no like", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotLike(String value) {
            addCriterion("order_no not like", value, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoIn(List<String> values) {
            addCriterion("order_no in", values, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotIn(List<String> values) {
            addCriterion("order_no not in", values, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoBetween(String value1, String value2) {
            addCriterion("order_no between", value1, value2, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderNoNotBetween(String value1, String value2) {
            addCriterion("order_no not between", value1, value2, "orderNo");
            return (Criteria) this;
        }

        public Criteria andOrderChildNoIsNull() {
            addCriterion("order_child_no is null");
            return (Criteria) this;
        }

        public Criteria andOrderChildNoIsNotNull() {
            addCriterion("order_child_no is not null");
            return (Criteria) this;
        }

        public Criteria andOrderChildNoEqualTo(String value) {
            addCriterion("order_child_no =", value, "orderChildNo");
            return (Criteria) this;
        }

        public Criteria andOrderChildNoNotEqualTo(String value) {
            addCriterion("order_child_no <>", value, "orderChildNo");
            return (Criteria) this;
        }

        public Criteria andOrderChildNoGreaterThan(String value) {
            addCriterion("order_child_no >", value, "orderChildNo");
            return (Criteria) this;
        }

        public Criteria andOrderChildNoGreaterThanOrEqualTo(String value) {
            addCriterion("order_child_no >=", value, "orderChildNo");
            return (Criteria) this;
        }

        public Criteria andOrderChildNoLessThan(String value) {
            addCriterion("order_child_no <", value, "orderChildNo");
            return (Criteria) this;
        }

        public Criteria andOrderChildNoLessThanOrEqualTo(String value) {
            addCriterion("order_child_no <=", value, "orderChildNo");
            return (Criteria) this;
        }

        public Criteria andOrderChildNoLike(String value) {
            addCriterion("order_child_no like", value, "orderChildNo");
            return (Criteria) this;
        }

        public Criteria andOrderChildNoNotLike(String value) {
            addCriterion("order_child_no not like", value, "orderChildNo");
            return (Criteria) this;
        }

        public Criteria andOrderChildNoIn(List<String> values) {
            addCriterion("order_child_no in", values, "orderChildNo");
            return (Criteria) this;
        }

        public Criteria andOrderChildNoNotIn(List<String> values) {
            addCriterion("order_child_no not in", values, "orderChildNo");
            return (Criteria) this;
        }

        public Criteria andOrderChildNoBetween(String value1, String value2) {
            addCriterion("order_child_no between", value1, value2, "orderChildNo");
            return (Criteria) this;
        }

        public Criteria andOrderChildNoNotBetween(String value1, String value2) {
            addCriterion("order_child_no not between", value1, value2, "orderChildNo");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNull() {
            addCriterion("user_id is null");
            return (Criteria) this;
        }

        public Criteria andUserIdIsNotNull() {
            addCriterion("user_id is not null");
            return (Criteria) this;
        }

        public Criteria andUserIdEqualTo(Long value) {
            addCriterion("user_id =", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotEqualTo(Long value) {
            addCriterion("user_id <>", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThan(Long value) {
            addCriterion("user_id >", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("user_id >=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThan(Long value) {
            addCriterion("user_id <", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdLessThanOrEqualTo(Long value) {
            addCriterion("user_id <=", value, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdIn(List<Long> values) {
            addCriterion("user_id in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotIn(List<Long> values) {
            addCriterion("user_id not in", values, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdBetween(Long value1, Long value2) {
            addCriterion("user_id between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andUserIdNotBetween(Long value1, Long value2) {
            addCriterion("user_id not between", value1, value2, "userId");
            return (Criteria) this;
        }

        public Criteria andUserPhoneIsNull() {
            addCriterion("user_phone is null");
            return (Criteria) this;
        }

        public Criteria andUserPhoneIsNotNull() {
            addCriterion("user_phone is not null");
            return (Criteria) this;
        }

        public Criteria andUserPhoneEqualTo(String value) {
            addCriterion("user_phone =", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneNotEqualTo(String value) {
            addCriterion("user_phone <>", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneGreaterThan(String value) {
            addCriterion("user_phone >", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneGreaterThanOrEqualTo(String value) {
            addCriterion("user_phone >=", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneLessThan(String value) {
            addCriterion("user_phone <", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneLessThanOrEqualTo(String value) {
            addCriterion("user_phone <=", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneLike(String value) {
            addCriterion("user_phone like", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneNotLike(String value) {
            addCriterion("user_phone not like", value, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneIn(List<String> values) {
            addCriterion("user_phone in", values, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneNotIn(List<String> values) {
            addCriterion("user_phone not in", values, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneBetween(String value1, String value2) {
            addCriterion("user_phone between", value1, value2, "userPhone");
            return (Criteria) this;
        }

        public Criteria andUserPhoneNotBetween(String value1, String value2) {
            addCriterion("user_phone not between", value1, value2, "userPhone");
            return (Criteria) this;
        }

        public Criteria andRefundOrderNoIsNull() {
            addCriterion("refund_order_no is null");
            return (Criteria) this;
        }

        public Criteria andRefundOrderNoIsNotNull() {
            addCriterion("refund_order_no is not null");
            return (Criteria) this;
        }

        public Criteria andRefundOrderNoEqualTo(String value) {
            addCriterion("refund_order_no =", value, "refundOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundOrderNoNotEqualTo(String value) {
            addCriterion("refund_order_no <>", value, "refundOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundOrderNoGreaterThan(String value) {
            addCriterion("refund_order_no >", value, "refundOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundOrderNoGreaterThanOrEqualTo(String value) {
            addCriterion("refund_order_no >=", value, "refundOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundOrderNoLessThan(String value) {
            addCriterion("refund_order_no <", value, "refundOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundOrderNoLessThanOrEqualTo(String value) {
            addCriterion("refund_order_no <=", value, "refundOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundOrderNoLike(String value) {
            addCriterion("refund_order_no like", value, "refundOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundOrderNoNotLike(String value) {
            addCriterion("refund_order_no not like", value, "refundOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundOrderNoIn(List<String> values) {
            addCriterion("refund_order_no in", values, "refundOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundOrderNoNotIn(List<String> values) {
            addCriterion("refund_order_no not in", values, "refundOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundOrderNoBetween(String value1, String value2) {
            addCriterion("refund_order_no between", value1, value2, "refundOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundOrderNoNotBetween(String value1, String value2) {
            addCriterion("refund_order_no not between", value1, value2, "refundOrderNo");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNoIsNull() {
            addCriterion("account_merchant_no is null");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNoIsNotNull() {
            addCriterion("account_merchant_no is not null");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNoEqualTo(String value) {
            addCriterion("account_merchant_no =", value, "accountMerchantNo");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNoNotEqualTo(String value) {
            addCriterion("account_merchant_no <>", value, "accountMerchantNo");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNoGreaterThan(String value) {
            addCriterion("account_merchant_no >", value, "accountMerchantNo");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNoGreaterThanOrEqualTo(String value) {
            addCriterion("account_merchant_no >=", value, "accountMerchantNo");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNoLessThan(String value) {
            addCriterion("account_merchant_no <", value, "accountMerchantNo");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNoLessThanOrEqualTo(String value) {
            addCriterion("account_merchant_no <=", value, "accountMerchantNo");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNoLike(String value) {
            addCriterion("account_merchant_no like", value, "accountMerchantNo");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNoNotLike(String value) {
            addCriterion("account_merchant_no not like", value, "accountMerchantNo");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNoIn(List<String> values) {
            addCriterion("account_merchant_no in", values, "accountMerchantNo");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNoNotIn(List<String> values) {
            addCriterion("account_merchant_no not in", values, "accountMerchantNo");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNoBetween(String value1, String value2) {
            addCriterion("account_merchant_no between", value1, value2, "accountMerchantNo");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantNoNotBetween(String value1, String value2) {
            addCriterion("account_merchant_no not between", value1, value2, "accountMerchantNo");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantKeyIsNull() {
            addCriterion("account_merchant_key is null");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantKeyIsNotNull() {
            addCriterion("account_merchant_key is not null");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantKeyEqualTo(String value) {
            addCriterion("account_merchant_key =", value, "accountMerchantKey");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantKeyNotEqualTo(String value) {
            addCriterion("account_merchant_key <>", value, "accountMerchantKey");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantKeyGreaterThan(String value) {
            addCriterion("account_merchant_key >", value, "accountMerchantKey");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantKeyGreaterThanOrEqualTo(String value) {
            addCriterion("account_merchant_key >=", value, "accountMerchantKey");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantKeyLessThan(String value) {
            addCriterion("account_merchant_key <", value, "accountMerchantKey");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantKeyLessThanOrEqualTo(String value) {
            addCriterion("account_merchant_key <=", value, "accountMerchantKey");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantKeyLike(String value) {
            addCriterion("account_merchant_key like", value, "accountMerchantKey");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantKeyNotLike(String value) {
            addCriterion("account_merchant_key not like", value, "accountMerchantKey");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantKeyIn(List<String> values) {
            addCriterion("account_merchant_key in", values, "accountMerchantKey");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantKeyNotIn(List<String> values) {
            addCriterion("account_merchant_key not in", values, "accountMerchantKey");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantKeyBetween(String value1, String value2) {
            addCriterion("account_merchant_key between", value1, value2, "accountMerchantKey");
            return (Criteria) this;
        }

        public Criteria andAccountMerchantKeyNotBetween(String value1, String value2) {
            addCriterion("account_merchant_key not between", value1, value2, "accountMerchantKey");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelIsNull() {
            addCriterion("refund_pay_channel is null");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelIsNotNull() {
            addCriterion("refund_pay_channel is not null");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelEqualTo(Integer value) {
            addCriterion("refund_pay_channel =", value, "refundPayChannel");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelNotEqualTo(Integer value) {
            addCriterion("refund_pay_channel <>", value, "refundPayChannel");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelGreaterThan(Integer value) {
            addCriterion("refund_pay_channel >", value, "refundPayChannel");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelGreaterThanOrEqualTo(Integer value) {
            addCriterion("refund_pay_channel >=", value, "refundPayChannel");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelLessThan(Integer value) {
            addCriterion("refund_pay_channel <", value, "refundPayChannel");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelLessThanOrEqualTo(Integer value) {
            addCriterion("refund_pay_channel <=", value, "refundPayChannel");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelIn(List<Integer> values) {
            addCriterion("refund_pay_channel in", values, "refundPayChannel");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelNotIn(List<Integer> values) {
            addCriterion("refund_pay_channel not in", values, "refundPayChannel");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelBetween(Integer value1, Integer value2) {
            addCriterion("refund_pay_channel between", value1, value2, "refundPayChannel");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelNotBetween(Integer value1, Integer value2) {
            addCriterion("refund_pay_channel not between", value1, value2, "refundPayChannel");
            return (Criteria) this;
        }

        public Criteria andReufndPayTypeIsNull() {
            addCriterion("reufnd_pay_type is null");
            return (Criteria) this;
        }

        public Criteria andReufndPayTypeIsNotNull() {
            addCriterion("reufnd_pay_type is not null");
            return (Criteria) this;
        }

        public Criteria andReufndPayTypeEqualTo(Integer value) {
            addCriterion("reufnd_pay_type =", value, "reufndPayType");
            return (Criteria) this;
        }

        public Criteria andReufndPayTypeNotEqualTo(Integer value) {
            addCriterion("reufnd_pay_type <>", value, "reufndPayType");
            return (Criteria) this;
        }

        public Criteria andReufndPayTypeGreaterThan(Integer value) {
            addCriterion("reufnd_pay_type >", value, "reufndPayType");
            return (Criteria) this;
        }

        public Criteria andReufndPayTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("reufnd_pay_type >=", value, "reufndPayType");
            return (Criteria) this;
        }

        public Criteria andReufndPayTypeLessThan(Integer value) {
            addCriterion("reufnd_pay_type <", value, "reufndPayType");
            return (Criteria) this;
        }

        public Criteria andReufndPayTypeLessThanOrEqualTo(Integer value) {
            addCriterion("reufnd_pay_type <=", value, "reufndPayType");
            return (Criteria) this;
        }

        public Criteria andReufndPayTypeIn(List<Integer> values) {
            addCriterion("reufnd_pay_type in", values, "reufndPayType");
            return (Criteria) this;
        }

        public Criteria andReufndPayTypeNotIn(List<Integer> values) {
            addCriterion("reufnd_pay_type not in", values, "reufndPayType");
            return (Criteria) this;
        }

        public Criteria andReufndPayTypeBetween(Integer value1, Integer value2) {
            addCriterion("reufnd_pay_type between", value1, value2, "reufndPayType");
            return (Criteria) this;
        }

        public Criteria andReufndPayTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("reufnd_pay_type not between", value1, value2, "reufndPayType");
            return (Criteria) this;
        }

        public Criteria andRefundSerialNoIsNull() {
            addCriterion("refund_serial_no is null");
            return (Criteria) this;
        }

        public Criteria andRefundSerialNoIsNotNull() {
            addCriterion("refund_serial_no is not null");
            return (Criteria) this;
        }

        public Criteria andRefundSerialNoEqualTo(String value) {
            addCriterion("refund_serial_no =", value, "refundSerialNo");
            return (Criteria) this;
        }

        public Criteria andRefundSerialNoNotEqualTo(String value) {
            addCriterion("refund_serial_no <>", value, "refundSerialNo");
            return (Criteria) this;
        }

        public Criteria andRefundSerialNoGreaterThan(String value) {
            addCriterion("refund_serial_no >", value, "refundSerialNo");
            return (Criteria) this;
        }

        public Criteria andRefundSerialNoGreaterThanOrEqualTo(String value) {
            addCriterion("refund_serial_no >=", value, "refundSerialNo");
            return (Criteria) this;
        }

        public Criteria andRefundSerialNoLessThan(String value) {
            addCriterion("refund_serial_no <", value, "refundSerialNo");
            return (Criteria) this;
        }

        public Criteria andRefundSerialNoLessThanOrEqualTo(String value) {
            addCriterion("refund_serial_no <=", value, "refundSerialNo");
            return (Criteria) this;
        }

        public Criteria andRefundSerialNoLike(String value) {
            addCriterion("refund_serial_no like", value, "refundSerialNo");
            return (Criteria) this;
        }

        public Criteria andRefundSerialNoNotLike(String value) {
            addCriterion("refund_serial_no not like", value, "refundSerialNo");
            return (Criteria) this;
        }

        public Criteria andRefundSerialNoIn(List<String> values) {
            addCriterion("refund_serial_no in", values, "refundSerialNo");
            return (Criteria) this;
        }

        public Criteria andRefundSerialNoNotIn(List<String> values) {
            addCriterion("refund_serial_no not in", values, "refundSerialNo");
            return (Criteria) this;
        }

        public Criteria andRefundSerialNoBetween(String value1, String value2) {
            addCriterion("refund_serial_no between", value1, value2, "refundSerialNo");
            return (Criteria) this;
        }

        public Criteria andRefundSerialNoNotBetween(String value1, String value2) {
            addCriterion("refund_serial_no not between", value1, value2, "refundSerialNo");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelOrderNoIsNull() {
            addCriterion("refund_pay_channel_order_no is null");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelOrderNoIsNotNull() {
            addCriterion("refund_pay_channel_order_no is not null");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelOrderNoEqualTo(String value) {
            addCriterion("refund_pay_channel_order_no =", value, "refundPayChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelOrderNoNotEqualTo(String value) {
            addCriterion("refund_pay_channel_order_no <>", value, "refundPayChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelOrderNoGreaterThan(String value) {
            addCriterion("refund_pay_channel_order_no >", value, "refundPayChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelOrderNoGreaterThanOrEqualTo(String value) {
            addCriterion("refund_pay_channel_order_no >=", value, "refundPayChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelOrderNoLessThan(String value) {
            addCriterion("refund_pay_channel_order_no <", value, "refundPayChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelOrderNoLessThanOrEqualTo(String value) {
            addCriterion("refund_pay_channel_order_no <=", value, "refundPayChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelOrderNoLike(String value) {
            addCriterion("refund_pay_channel_order_no like", value, "refundPayChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelOrderNoNotLike(String value) {
            addCriterion("refund_pay_channel_order_no not like", value, "refundPayChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelOrderNoIn(List<String> values) {
            addCriterion("refund_pay_channel_order_no in", values, "refundPayChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelOrderNoNotIn(List<String> values) {
            addCriterion("refund_pay_channel_order_no not in", values, "refundPayChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelOrderNoBetween(String value1, String value2) {
            addCriterion("refund_pay_channel_order_no between", value1, value2, "refundPayChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundPayChannelOrderNoNotBetween(String value1, String value2) {
            addCriterion("refund_pay_channel_order_no not between", value1, value2, "refundPayChannelOrderNo");
            return (Criteria) this;
        }

        public Criteria andRefundPriceIsNull() {
            addCriterion("refund_price is null");
            return (Criteria) this;
        }

        public Criteria andRefundPriceIsNotNull() {
            addCriterion("refund_price is not null");
            return (Criteria) this;
        }

        public Criteria andRefundPriceEqualTo(BigDecimal value) {
            addCriterion("refund_price =", value, "refundPrice");
            return (Criteria) this;
        }

        public Criteria andRefundPriceNotEqualTo(BigDecimal value) {
            addCriterion("refund_price <>", value, "refundPrice");
            return (Criteria) this;
        }

        public Criteria andRefundPriceGreaterThan(BigDecimal value) {
            addCriterion("refund_price >", value, "refundPrice");
            return (Criteria) this;
        }

        public Criteria andRefundPriceGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("refund_price >=", value, "refundPrice");
            return (Criteria) this;
        }

        public Criteria andRefundPriceLessThan(BigDecimal value) {
            addCriterion("refund_price <", value, "refundPrice");
            return (Criteria) this;
        }

        public Criteria andRefundPriceLessThanOrEqualTo(BigDecimal value) {
            addCriterion("refund_price <=", value, "refundPrice");
            return (Criteria) this;
        }

        public Criteria andRefundPriceIn(List<BigDecimal> values) {
            addCriterion("refund_price in", values, "refundPrice");
            return (Criteria) this;
        }

        public Criteria andRefundPriceNotIn(List<BigDecimal> values) {
            addCriterion("refund_price not in", values, "refundPrice");
            return (Criteria) this;
        }

        public Criteria andRefundPriceBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("refund_price between", value1, value2, "refundPrice");
            return (Criteria) this;
        }

        public Criteria andRefundPriceNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("refund_price not between", value1, value2, "refundPrice");
            return (Criteria) this;
        }

        public Criteria andRefundIntegralIsNull() {
            addCriterion("refund_integral is null");
            return (Criteria) this;
        }

        public Criteria andRefundIntegralIsNotNull() {
            addCriterion("refund_integral is not null");
            return (Criteria) this;
        }

        public Criteria andRefundIntegralEqualTo(Long value) {
            addCriterion("refund_integral =", value, "refundIntegral");
            return (Criteria) this;
        }

        public Criteria andRefundIntegralNotEqualTo(Long value) {
            addCriterion("refund_integral <>", value, "refundIntegral");
            return (Criteria) this;
        }

        public Criteria andRefundIntegralGreaterThan(Long value) {
            addCriterion("refund_integral >", value, "refundIntegral");
            return (Criteria) this;
        }

        public Criteria andRefundIntegralGreaterThanOrEqualTo(Long value) {
            addCriterion("refund_integral >=", value, "refundIntegral");
            return (Criteria) this;
        }

        public Criteria andRefundIntegralLessThan(Long value) {
            addCriterion("refund_integral <", value, "refundIntegral");
            return (Criteria) this;
        }

        public Criteria andRefundIntegralLessThanOrEqualTo(Long value) {
            addCriterion("refund_integral <=", value, "refundIntegral");
            return (Criteria) this;
        }

        public Criteria andRefundIntegralIn(List<Long> values) {
            addCriterion("refund_integral in", values, "refundIntegral");
            return (Criteria) this;
        }

        public Criteria andRefundIntegralNotIn(List<Long> values) {
            addCriterion("refund_integral not in", values, "refundIntegral");
            return (Criteria) this;
        }

        public Criteria andRefundIntegralBetween(Long value1, Long value2) {
            addCriterion("refund_integral between", value1, value2, "refundIntegral");
            return (Criteria) this;
        }

        public Criteria andRefundIntegralNotBetween(Long value1, Long value2) {
            addCriterion("refund_integral not between", value1, value2, "refundIntegral");
            return (Criteria) this;
        }

        public Criteria andRefundRemarkIsNull() {
            addCriterion("refund_remark is null");
            return (Criteria) this;
        }

        public Criteria andRefundRemarkIsNotNull() {
            addCriterion("refund_remark is not null");
            return (Criteria) this;
        }

        public Criteria andRefundRemarkEqualTo(String value) {
            addCriterion("refund_remark =", value, "refundRemark");
            return (Criteria) this;
        }

        public Criteria andRefundRemarkNotEqualTo(String value) {
            addCriterion("refund_remark <>", value, "refundRemark");
            return (Criteria) this;
        }

        public Criteria andRefundRemarkGreaterThan(String value) {
            addCriterion("refund_remark >", value, "refundRemark");
            return (Criteria) this;
        }

        public Criteria andRefundRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("refund_remark >=", value, "refundRemark");
            return (Criteria) this;
        }

        public Criteria andRefundRemarkLessThan(String value) {
            addCriterion("refund_remark <", value, "refundRemark");
            return (Criteria) this;
        }

        public Criteria andRefundRemarkLessThanOrEqualTo(String value) {
            addCriterion("refund_remark <=", value, "refundRemark");
            return (Criteria) this;
        }

        public Criteria andRefundRemarkLike(String value) {
            addCriterion("refund_remark like", value, "refundRemark");
            return (Criteria) this;
        }

        public Criteria andRefundRemarkNotLike(String value) {
            addCriterion("refund_remark not like", value, "refundRemark");
            return (Criteria) this;
        }

        public Criteria andRefundRemarkIn(List<String> values) {
            addCriterion("refund_remark in", values, "refundRemark");
            return (Criteria) this;
        }

        public Criteria andRefundRemarkNotIn(List<String> values) {
            addCriterion("refund_remark not in", values, "refundRemark");
            return (Criteria) this;
        }

        public Criteria andRefundRemarkBetween(String value1, String value2) {
            addCriterion("refund_remark between", value1, value2, "refundRemark");
            return (Criteria) this;
        }

        public Criteria andRefundRemarkNotBetween(String value1, String value2) {
            addCriterion("refund_remark not between", value1, value2, "refundRemark");
            return (Criteria) this;
        }

        public Criteria andRefundStatusIsNull() {
            addCriterion("refund_status is null");
            return (Criteria) this;
        }

        public Criteria andRefundStatusIsNotNull() {
            addCriterion("refund_status is not null");
            return (Criteria) this;
        }

        public Criteria andRefundStatusEqualTo(Integer value) {
            addCriterion("refund_status =", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusNotEqualTo(Integer value) {
            addCriterion("refund_status <>", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusGreaterThan(Integer value) {
            addCriterion("refund_status >", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusGreaterThanOrEqualTo(Integer value) {
            addCriterion("refund_status >=", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusLessThan(Integer value) {
            addCriterion("refund_status <", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusLessThanOrEqualTo(Integer value) {
            addCriterion("refund_status <=", value, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusIn(List<Integer> values) {
            addCriterion("refund_status in", values, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusNotIn(List<Integer> values) {
            addCriterion("refund_status not in", values, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusBetween(Integer value1, Integer value2) {
            addCriterion("refund_status between", value1, value2, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundStatusNotBetween(Integer value1, Integer value2) {
            addCriterion("refund_status not between", value1, value2, "refundStatus");
            return (Criteria) this;
        }

        public Criteria andRefundFailReasonIsNull() {
            addCriterion("refund_fail_reason is null");
            return (Criteria) this;
        }

        public Criteria andRefundFailReasonIsNotNull() {
            addCriterion("refund_fail_reason is not null");
            return (Criteria) this;
        }

        public Criteria andRefundFailReasonEqualTo(String value) {
            addCriterion("refund_fail_reason =", value, "refundFailReason");
            return (Criteria) this;
        }

        public Criteria andRefundFailReasonNotEqualTo(String value) {
            addCriterion("refund_fail_reason <>", value, "refundFailReason");
            return (Criteria) this;
        }

        public Criteria andRefundFailReasonGreaterThan(String value) {
            addCriterion("refund_fail_reason >", value, "refundFailReason");
            return (Criteria) this;
        }

        public Criteria andRefundFailReasonGreaterThanOrEqualTo(String value) {
            addCriterion("refund_fail_reason >=", value, "refundFailReason");
            return (Criteria) this;
        }

        public Criteria andRefundFailReasonLessThan(String value) {
            addCriterion("refund_fail_reason <", value, "refundFailReason");
            return (Criteria) this;
        }

        public Criteria andRefundFailReasonLessThanOrEqualTo(String value) {
            addCriterion("refund_fail_reason <=", value, "refundFailReason");
            return (Criteria) this;
        }

        public Criteria andRefundFailReasonLike(String value) {
            addCriterion("refund_fail_reason like", value, "refundFailReason");
            return (Criteria) this;
        }

        public Criteria andRefundFailReasonNotLike(String value) {
            addCriterion("refund_fail_reason not like", value, "refundFailReason");
            return (Criteria) this;
        }

        public Criteria andRefundFailReasonIn(List<String> values) {
            addCriterion("refund_fail_reason in", values, "refundFailReason");
            return (Criteria) this;
        }

        public Criteria andRefundFailReasonNotIn(List<String> values) {
            addCriterion("refund_fail_reason not in", values, "refundFailReason");
            return (Criteria) this;
        }

        public Criteria andRefundFailReasonBetween(String value1, String value2) {
            addCriterion("refund_fail_reason between", value1, value2, "refundFailReason");
            return (Criteria) this;
        }

        public Criteria andRefundFailReasonNotBetween(String value1, String value2) {
            addCriterion("refund_fail_reason not between", value1, value2, "refundFailReason");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("create_time is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("create_time is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("create_time =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("create_time <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("create_time >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("create_time >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("create_time <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("create_time <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("create_time in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("create_time not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("create_time between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("create_time not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("update_time is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("update_time is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("update_time =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("update_time <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("update_time >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("update_time >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("update_time <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("update_time <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("update_time in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("update_time not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("update_time between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("update_time not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeIsNull() {
            addCriterion("finish_time is null");
            return (Criteria) this;
        }

        public Criteria andFinishTimeIsNotNull() {
            addCriterion("finish_time is not null");
            return (Criteria) this;
        }

        public Criteria andFinishTimeEqualTo(Date value) {
            addCriterion("finish_time =", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeNotEqualTo(Date value) {
            addCriterion("finish_time <>", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeGreaterThan(Date value) {
            addCriterion("finish_time >", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("finish_time >=", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeLessThan(Date value) {
            addCriterion("finish_time <", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeLessThanOrEqualTo(Date value) {
            addCriterion("finish_time <=", value, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeIn(List<Date> values) {
            addCriterion("finish_time in", values, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeNotIn(List<Date> values) {
            addCriterion("finish_time not in", values, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeBetween(Date value1, Date value2) {
            addCriterion("finish_time between", value1, value2, "finishTime");
            return (Criteria) this;
        }

        public Criteria andFinishTimeNotBetween(Date value1, Date value2) {
            addCriterion("finish_time not between", value1, value2, "finishTime");
            return (Criteria) this;
        }

        public Criteria andOpUserTypeIsNull() {
            addCriterion("op_user_type is null");
            return (Criteria) this;
        }

        public Criteria andOpUserTypeIsNotNull() {
            addCriterion("op_user_type is not null");
            return (Criteria) this;
        }

        public Criteria andOpUserTypeEqualTo(Integer value) {
            addCriterion("op_user_type =", value, "opUserType");
            return (Criteria) this;
        }

        public Criteria andOpUserTypeNotEqualTo(Integer value) {
            addCriterion("op_user_type <>", value, "opUserType");
            return (Criteria) this;
        }

        public Criteria andOpUserTypeGreaterThan(Integer value) {
            addCriterion("op_user_type >", value, "opUserType");
            return (Criteria) this;
        }

        public Criteria andOpUserTypeGreaterThanOrEqualTo(Integer value) {
            addCriterion("op_user_type >=", value, "opUserType");
            return (Criteria) this;
        }

        public Criteria andOpUserTypeLessThan(Integer value) {
            addCriterion("op_user_type <", value, "opUserType");
            return (Criteria) this;
        }

        public Criteria andOpUserTypeLessThanOrEqualTo(Integer value) {
            addCriterion("op_user_type <=", value, "opUserType");
            return (Criteria) this;
        }

        public Criteria andOpUserTypeIn(List<Integer> values) {
            addCriterion("op_user_type in", values, "opUserType");
            return (Criteria) this;
        }

        public Criteria andOpUserTypeNotIn(List<Integer> values) {
            addCriterion("op_user_type not in", values, "opUserType");
            return (Criteria) this;
        }

        public Criteria andOpUserTypeBetween(Integer value1, Integer value2) {
            addCriterion("op_user_type between", value1, value2, "opUserType");
            return (Criteria) this;
        }

        public Criteria andOpUserTypeNotBetween(Integer value1, Integer value2) {
            addCriterion("op_user_type not between", value1, value2, "opUserType");
            return (Criteria) this;
        }

        public Criteria andOpUserIdIsNull() {
            addCriterion("op_user_id is null");
            return (Criteria) this;
        }

        public Criteria andOpUserIdIsNotNull() {
            addCriterion("op_user_id is not null");
            return (Criteria) this;
        }

        public Criteria andOpUserIdEqualTo(Long value) {
            addCriterion("op_user_id =", value, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdNotEqualTo(Long value) {
            addCriterion("op_user_id <>", value, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdGreaterThan(Long value) {
            addCriterion("op_user_id >", value, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdGreaterThanOrEqualTo(Long value) {
            addCriterion("op_user_id >=", value, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdLessThan(Long value) {
            addCriterion("op_user_id <", value, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdLessThanOrEqualTo(Long value) {
            addCriterion("op_user_id <=", value, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdIn(List<Long> values) {
            addCriterion("op_user_id in", values, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdNotIn(List<Long> values) {
            addCriterion("op_user_id not in", values, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdBetween(Long value1, Long value2) {
            addCriterion("op_user_id between", value1, value2, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserIdNotBetween(Long value1, Long value2) {
            addCriterion("op_user_id not between", value1, value2, "opUserId");
            return (Criteria) this;
        }

        public Criteria andOpUserNameIsNull() {
            addCriterion("op_user_name is null");
            return (Criteria) this;
        }

        public Criteria andOpUserNameIsNotNull() {
            addCriterion("op_user_name is not null");
            return (Criteria) this;
        }

        public Criteria andOpUserNameEqualTo(String value) {
            addCriterion("op_user_name =", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameNotEqualTo(String value) {
            addCriterion("op_user_name <>", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameGreaterThan(String value) {
            addCriterion("op_user_name >", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameGreaterThanOrEqualTo(String value) {
            addCriterion("op_user_name >=", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameLessThan(String value) {
            addCriterion("op_user_name <", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameLessThanOrEqualTo(String value) {
            addCriterion("op_user_name <=", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameLike(String value) {
            addCriterion("op_user_name like", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameNotLike(String value) {
            addCriterion("op_user_name not like", value, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameIn(List<String> values) {
            addCriterion("op_user_name in", values, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameNotIn(List<String> values) {
            addCriterion("op_user_name not in", values, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameBetween(String value1, String value2) {
            addCriterion("op_user_name between", value1, value2, "opUserName");
            return (Criteria) this;
        }

        public Criteria andOpUserNameNotBetween(String value1, String value2) {
            addCriterion("op_user_name not between", value1, value2, "opUserName");
            return (Criteria) this;
        }

        public Criteria andExt1IsNull() {
            addCriterion("ext_1 is null");
            return (Criteria) this;
        }

        public Criteria andExt1IsNotNull() {
            addCriterion("ext_1 is not null");
            return (Criteria) this;
        }

        public Criteria andExt1EqualTo(String value) {
            addCriterion("ext_1 =", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotEqualTo(String value) {
            addCriterion("ext_1 <>", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThan(String value) {
            addCriterion("ext_1 >", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1GreaterThanOrEqualTo(String value) {
            addCriterion("ext_1 >=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThan(String value) {
            addCriterion("ext_1 <", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1LessThanOrEqualTo(String value) {
            addCriterion("ext_1 <=", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Like(String value) {
            addCriterion("ext_1 like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotLike(String value) {
            addCriterion("ext_1 not like", value, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1In(List<String> values) {
            addCriterion("ext_1 in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotIn(List<String> values) {
            addCriterion("ext_1 not in", values, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1Between(String value1, String value2) {
            addCriterion("ext_1 between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt1NotBetween(String value1, String value2) {
            addCriterion("ext_1 not between", value1, value2, "ext1");
            return (Criteria) this;
        }

        public Criteria andExt2IsNull() {
            addCriterion("ext_2 is null");
            return (Criteria) this;
        }

        public Criteria andExt2IsNotNull() {
            addCriterion("ext_2 is not null");
            return (Criteria) this;
        }

        public Criteria andExt2EqualTo(String value) {
            addCriterion("ext_2 =", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotEqualTo(String value) {
            addCriterion("ext_2 <>", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThan(String value) {
            addCriterion("ext_2 >", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2GreaterThanOrEqualTo(String value) {
            addCriterion("ext_2 >=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThan(String value) {
            addCriterion("ext_2 <", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2LessThanOrEqualTo(String value) {
            addCriterion("ext_2 <=", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Like(String value) {
            addCriterion("ext_2 like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotLike(String value) {
            addCriterion("ext_2 not like", value, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2In(List<String> values) {
            addCriterion("ext_2 in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotIn(List<String> values) {
            addCriterion("ext_2 not in", values, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2Between(String value1, String value2) {
            addCriterion("ext_2 between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt2NotBetween(String value1, String value2) {
            addCriterion("ext_2 not between", value1, value2, "ext2");
            return (Criteria) this;
        }

        public Criteria andExt3IsNull() {
            addCriterion("ext_3 is null");
            return (Criteria) this;
        }

        public Criteria andExt3IsNotNull() {
            addCriterion("ext_3 is not null");
            return (Criteria) this;
        }

        public Criteria andExt3EqualTo(String value) {
            addCriterion("ext_3 =", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotEqualTo(String value) {
            addCriterion("ext_3 <>", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThan(String value) {
            addCriterion("ext_3 >", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3GreaterThanOrEqualTo(String value) {
            addCriterion("ext_3 >=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThan(String value) {
            addCriterion("ext_3 <", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3LessThanOrEqualTo(String value) {
            addCriterion("ext_3 <=", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Like(String value) {
            addCriterion("ext_3 like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotLike(String value) {
            addCriterion("ext_3 not like", value, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3In(List<String> values) {
            addCriterion("ext_3 in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotIn(List<String> values) {
            addCriterion("ext_3 not in", values, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3Between(String value1, String value2) {
            addCriterion("ext_3 between", value1, value2, "ext3");
            return (Criteria) this;
        }

        public Criteria andExt3NotBetween(String value1, String value2) {
            addCriterion("ext_3 not between", value1, value2, "ext3");
            return (Criteria) this;
        }
    }

    /**
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}